package com.mortals.xhx.module.perform.web;
import cn.hutool.core.date.DateUtil;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.OrderCol;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.base.system.user.model.UserQuery;
import com.mortals.xhx.base.system.user.service.UserService;
import com.mortals.xhx.common.code.*;
import com.mortals.xhx.module.dept.model.DeptQuery;
import com.mortals.xhx.module.dept.service.DeptService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.perform.model.PerformOtherRecordEntity;
import com.mortals.xhx.module.perform.service.PerformOtherRecordService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;

import java.time.LocalDateTime;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import com.alibaba.fastjson.JSONObject;
import java.util.Arrays;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import static com.mortals.framework.ap.SysConstains.*;
/**
*
* 其它绩效记录信息
*
* @author zxfei
* @date 2023-07-11
*/
@RestController
@RequestMapping("perform/other/record")
public class PerformOtherRecordController extends BaseCRUDJsonBodyMappingController<PerformOtherRecordService,PerformOtherRecordEntity,Long> {

    @Autowired
    private ParamService paramService;
    @Autowired
    private UserService userService;
    @Autowired
    private DeptService deptService;
    public PerformOtherRecordController(){
        super.setModuleDesc( "其它绩效记录信息");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "irregularOtherType", paramService.getParamBySecondOrganize("PerformOtherRecord","irregularOtherType"));
        this.addDict(model, "processStatus", ProcessStatusEnum.getEnumMap());
        this.addDict(model, "checkStatus", CheckStatusEnum.getEnumMap());
        this.addDict(model, "subMethod", SubMethodEnum.getEnumMap());
        this.addDict(model, "subAddType", SubAddTypeEnum.getEnumMap());
        this.addDict(model, "checkType", CheckTypeEnum.getEnumMap());
        this.addDict(model, "deptId", deptService.find(new DeptQuery()).stream().collect(Collectors.toMap(x -> x.getId().toString(), y -> y.getDeptName())));


        Map<String, String> collect = userService.find(new UserQuery(), getContext()).stream()
                .collect(Collectors.toMap(x -> x.getId().toString(), y -> y.getRealName(), (o, n) -> n));

        this.addDict(model, "createUserId", collect);

        super.init(model, context);
    }

    @Override
    protected void doListBefore(PerformOtherRecordEntity query, Map<String, Object> model, Context context) throws AppException {
        if (ObjectUtils.isEmpty(query.getOrderColList())) {
            query.setOrderColList(Arrays.asList(new OrderCol("happenTime", OrderCol.DESCENDING)));
        } else {
            query.getOrderColList().add(new OrderCol("happenTime", OrderCol.DESCENDING));
        }

        if(ObjectUtils.isEmpty(query.getHappenTimeStart())){
            LocalDateTime currentDate = LocalDateTime.now();
            LocalDateTime firstDayOfMonth = currentDate.withDayOfMonth(1);
            query.setHappenTimeStart(DateUtil.format(firstDayOfMonth,"yyyy-MM-dd"));
            //query.setHappenTimeEnd(DateUtil.formatDate(query.getCreateTime()));
        }
    }
}